"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = refetch;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _apolloClient = require("apollo-client");

var _getSchemaTypes = _interopRequireDefault(require("./getSchemaTypes"));

var _doesQueryContain = _interopRequireDefault(require("./doesQueryContain"));

function normalizeIds(ids) {
  if (ids instanceof Set) return ids;
  if (Array.isArray(ids)) return new Set(ids);
  return new Set([ids]);
}

function every(array, predicate) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = array[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _elem = _step.value;
      if (!predicate(_elem)) return false;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return true;
}

function refetch(_x, _x2, _x3, _x4) {
  return _refetch.apply(this, arguments);
}

function _refetch() {
  _refetch = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(client, typenameOrTerms, ids, idField) {
    var types, terms, queries, promises, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _loop, _iterator2, _step2, _ret;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (client instanceof _apolloClient.ApolloClient) {
              _context.next = 2;
              break;
            }

            throw new Error("client must be an ApolloClient, instead got: ".concat(String(client)));

          case 2:
            _context.next = 4;
            return (0, _getSchemaTypes.default)(client);

          case 4:
            types = _context.sent;

            if (!(typeof typenameOrTerms === 'string')) {
              _context.next = 9;
              break;
            }

            terms = [[typenameOrTerms, ids, idField]];
            _context.next = 14;
            break;

          case 9:
            if (!Array.isArray(typenameOrTerms)) {
              _context.next = 13;
              break;
            }

            terms = typenameOrTerms;
            _context.next = 14;
            break;

          case 13:
            throw new Error("invalid typename or terms: ".concat(typenameOrTerms));

          case 14:
            queries = client.queryManager.queries;
            promises = [];
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context.prev = 19;

            _loop = function _loop() {
              var query = _step2.value;
              var document = query.document,
                  observableQuery = query.observableQuery;
              if (!observableQuery) return "continue";
              var data = void 0;
              var currentResult = observableQuery.currentResult();
              if (currentResult) data = currentResult.data;

              if (every(terms, function (_ref) {
                var _ref2 = (0, _slicedToArray2.default)(_ref, 3),
                    typename = _ref2[0],
                    ids = _ref2[1],
                    idField = _ref2[2];

                return (0, _doesQueryContain.default)(document, types, typename, data, ids != null ? normalizeIds(ids) : null, idField || 'id');
              })) {
                promises.push(observableQuery.refetch());
              }
            };

            _iterator2 = queries.values()[Symbol.iterator]();

          case 22:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context.next = 29;
              break;
            }

            _ret = _loop();

            if (!(_ret === "continue")) {
              _context.next = 26;
              break;
            }

            return _context.abrupt("continue", 26);

          case 26:
            _iteratorNormalCompletion2 = true;
            _context.next = 22;
            break;

          case 29:
            _context.next = 35;
            break;

          case 31:
            _context.prev = 31;
            _context.t0 = _context["catch"](19);
            _didIteratorError2 = true;
            _iteratorError2 = _context.t0;

          case 35:
            _context.prev = 35;
            _context.prev = 36;

            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
              _iterator2.return();
            }

          case 38:
            _context.prev = 38;

            if (!_didIteratorError2) {
              _context.next = 41;
              break;
            }

            throw _iteratorError2;

          case 41:
            return _context.finish(38);

          case 42:
            return _context.finish(35);

          case 43:
            _context.next = 45;
            return promises;

          case 45:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[19, 31, 35, 43], [36,, 38, 42]]);
  }));
  return _refetch.apply(this, arguments);
}